App({
  onLaunch: function () {
    let updateManager = wx.getUpdateManager()
    updateManager.onCheckForUpdate(function (res) {
      console.log(res.hasUpdate)
    })

    updateManager.onUpdateReady(function () {
      wx.showModal({
        title: '更新提示',
        content: '新版本已经准备好，是否重启应用?',
        success(res) {
          if (res.confirm) {
            updateManager.applyUpdate()
          }
        }
      })
    })
    updateManager.onUpdateFailed(function () {
      wx.showToast({
        title: '更新失败',
        icon: 'none'
      })
    })

  },
  config: require('utils/config.js'), //全局配置信息
  api: require('utils/api.js'), //接口文档
  db: require('utils/db.js'), //本地存储
  common: require('utils/common.js'),
  globalData: {
    userInfo: null,
    // navHeight: 0
    music: '',
    code: '', // 登录注册用
    user_id: 0,
    upload_image_url: 'https://ydxcx.mufengnet.com/api/up_files/upload_image'
  }
}) 
 