const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        info: {
            id: 0,
            receiving_name: '',
            receiving_phone: '',
            code: '',
            skill_introduction: ''
        },
        lock: false,
        time: 60,
        lock_code: false,
        btn_desc: '获取验证码'
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        let page = this
        page.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                page.setData({
                    screenWidth: res.screenWidth
                });
            }
        })

        let uid = app.db.get('element_uid'), info = page.data.info
        info.id = uid
        this.setData({
            info: info
        })
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        
    },

    /**
     * 发送验证码
     */
    sendCode: function () {
        let page = this, mobile = page.data.info.receiving_phone, lock_code = page.data.lock_code
        if (!/^1[3456789]\d{9}$/.test(mobile)) {
            wx.showToast({
              title: '请输入正确格式的手机号',
              icon: 'none'
            })
            return
        }
        if (lock_code) {
            return
        }
        app.api.senSmsCode ({phone: mobile}, function (res) {
console.log(res)            
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                page.timeOut()
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 倒计时
     */
    timeOut: function () {
        let page = this, time = page.data.time
        if (time > 1) {
            time--
            page.setData({
                lock_code: true,
                time: time,
                btn_desc: time+' s'
            })
            page.timeOutSingle = setTimeout (function () {
                page.timeOut()
            },1000)
        } else {
            page.setData({
                lock_code: false,
                time: 60,
                btn_desc: '获取验证码'
            })
            clearTimeout(page.timeOutSingle)
        }
    },

    /**
     * 输入框
     */
    setInputValue: function (e) {
        let name = e.currentTarget.dataset.name, value = e.detail.value, info = this.data.info
        info[name] = value
        this.setData({
            info: info
        })
    },

    //提交申请
    setAction: function () {
        let page = this, info = page.data.info, lock = page.data.lock
        if (!info.receiving_name) {
            wx.showToast({
              title: '请输入姓名',
              icon: 'none'
            })
            return
        }
        if (!info.receiving_phone) {
            wx.showToast({
              title: '请输入联系电话',
              icon: 'none'
            })
            return
        }
        if (!/^1[3456789]\d{9}$/.test(info.receiving_phone)) {
            wx.showToast({
              title: '手机号格式错误',
              icon: 'none'
            })
            return
        }
        if (!info.code) {
            wx.showToast({
              title: '请输入验证码',
              icon: 'none'
            })
            return
        }
        if (!info.skill_introduction) {
            wx.showToast({
              title: '请输入技能介绍',
              icon: 'none'
            })
            return
        }
        if (lock) {
            return
        }
        page.setData({
            lock: true
        })

        console.log(info)
        app.api.applyStaff(info, function (res) {
            page.setData({
                lock: false
            })
            console.log(res)
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                setTimeout(function () {
                    wx.navigateBack({
                      delta: 1,
                    })    
                },1500)
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})