const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        //选项卡
        tabActiveId: 1,
        array: [], //身份
        array2: [], //证件
        //省市区
        region: [],
        regionString: '',
        //上传
        shenfenZ: '',
        shenfenF: '',
        data: {
            identity_information: 1,
            username: '',  
            region: '',
            workname: '',
            working_direction: '',
            identity: '',
            certificates: '',
            tutor: '',
            email: '',
            QQ: '',
            front_certificate: ''  ,
            reverse_certificate: '',
            working_address: '',
            enterprise_number: ''
        },
        config: {},
        disabled: false,
        isAuth: false,
        authId: 0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            disabled: options.status == 2 ? true : false,
            isAuth: options.status == 2 ? true : false
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getAuthIdentityInfo()
        this.getCertInfo()
        this.getUploadConfig()
        this.getUserIdentifyInfo()
    },

    /**
     * 获取上传配置
     */
    getUploadConfig: function () {
        let page = this
        app.api.getUploadConfig("", function (res) {
            if (res.code > 0) {
                page.setData({
                    config: res.data
                })
            }
        })
    },

    /**
     * 获取身份信息
     */
    getAuthIdentityInfo: function () {
        let page = this, array = []
        app.api.getAuthIdentityInfo("", function (res) {
            if (res.code > 0) {
                for (let i=0; i<res.data.length; i++) {
                    array.push(res.data[i].title)
                }
                page.setData({
                    array: array
                })
            }
        })
    },  

    /**
     * 获取证件信息
     */
    getCertInfo: function () {
        let page = this, array2 = []
        app.api.getCertInfo("", function (res) {
            if (res.code > 0) {
                for (let i=0; i<res.data.length; i++) {
                    array2.push(res.data[i].title)
                }
                page.setData({
                    array2: array2
                })
            }
        })
    },

    /**
     * 获取用户填写的信息
     */
    getUserIdentifyInfo: function () {
        let page = this, data = page.data.data
        app.api.getUserIdentifyInfo("", function (res) {
            console.log(res)
            if (res.code > 0) {
                if (res.data.hasOwnProperty('authentication_status')) {
                    data.identity_information = res.data.type 
                    data.username = res.data.username
                    data.region = res.data.region
                    if (res.data.hasOwnProperty('workname')) {
                        data.workname = res.data.workname
                    }
                    if (res.data.hasOwnProperty('working_direction')) {
                        data.working_direction = res.data.working_direction
                    }
                    if (res.data.hasOwnProperty('identity')) {
                        data.identity = res.data.identity
                    }
                    data.certificates = res.data.certificates
                    if (res.data.hasOwnProperty('tutor')) {
                        data.tutor = res.data.tutor
                    }
                    data.email = res.data.email
                    data.QQ = res.data.QQ
                    if (res.data.hasOwnProperty('working_address')) {
                        data.working_address = res.data.working_address
                    }
                    if (res.data.hasOwnProperty('enterprise_number')) {
                        data.enterprise_number = res.data.enterprise_number
                    }

                    let array = page.data.array, array2 = page.data.array2
                    let index = '', index2 = ''
                    if (res.data.hasOwnProperty('identity')) {
                        for (let i=0; i<array.length; i++) {
                            if (array[i] == res.data.identity) {
                                index = i
                            }
                        }
                    }
                    for (let k=0; k<array2.length; k++) {
                        if (array2[k] == res.data.certificates) {
                            index2 = k
                        }
                    }
                    page.setData({
                        data: data,
                        regionString: res.data.region,
                        index: index,
                        index2: index2,
                        authId: res.data.id,
                        tabActiveId: res.data.type
                    })
                }
            }
        })
    },

    /**
     * 选项卡
     */
    tabClick(e) {
        let page = this, data = page.data.data, d = e.currentTarget.dataset, isAuth = page.data.isAuth;
        if (data.identity_information == d.id) {
            return
        }
        if (isAuth) {
            wx.showToast({
              title: '已认证，不可切换',
              icon: 'none'
            })
            return
        }
        // data.identity_information = d.id
        this.setData({
            tabActiveId: d.id,
            [`data.identity_information`]: d.id
        })
    },
    /**
     * 身份 
     */
    bindPickerChange: function (e) {
        let page = this, array = page.data.array, isAuth = page.data.isAuth
        if (isAuth) {
            wx.showToast({
                title: '已认证，不可修改',
                icon: 'none'
              })
              return
        }
        page.setData({
            index: e.detail.value,
            [`data.identity`]: array[e.detail.value]
        })
    },
    /**
     * 证件 
     */
    bindCertificateChange: function (e) {
        let page = this, array2 = page.data.array2, isAuth = page.data.isAuth
        if (isAuth) {
            wx.showToast({
                title: '已认证，不可修改',
                icon: 'none'
              })
              return
        }
        page.setData({
            index2: e.detail.value,
            [`data.certificates`]: array2[e.detail.value]
        })
    },

    /**
     * 省市区
     */
    bindRegionChange: function (e) {
        let region = e.detail.value;
        let regionString = region[0] + '-' + region[1] + '-' + region[2];
        if (this.data.isAuth) {
            wx.showToast({
                title: '已认证，不可修改',
                icon: 'none'
              })
              return
        }
        this.setData({
            region: e.detail.value,
            regionString: regionString,
            [`data.region`]: region[0]+region[1]+region[2]
        })
    },
    /**
     * 上传照片
     */
    uploadImg(e) {
        let page = this, dataPost = page.data.data, certType = e.currentTarget.dataset.key, config = page.data.config;

        if (!config.hasOwnProperty('policy')) {
            wx.showToast({
              title: '上传配置错误',
              icon: 'none'
            })
            return
        }
        wx.chooseImage({
            count: 1,
            sizeType: ['original', 'compressed'],
            sourceType: ['album', 'camera'],
            success(res) {
                let item = res.tempFilePaths[0];
                let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png'
                wx.showLoading({
                    title: '上传中...',
                    icon: 'loading',
                    mask: true
                })
                wx.uploadFile({
                    url: config.host,
                    filePath: item,
                    name: 'file',
                    formData: {
                        key: key,
                        policy: config.policy, // 输入你获取的的policy
        
                        OSSAccessKeyId: config.OSSAccessKeyId, // 输入你的AccessKeyId
        
                        success_action_status: '200', // 让服务端返回200,不然，默认会返回204
        
                        signature: config.Signature, // 输入你获取的的signature
        
                    },
                    success(res) {
                        console.log(res)
                        wx.hideLoading();
                        if (res.statusCode == 200) {
                            dataPost[certType] = config.host + '/' + key
                            page.setData({
                                data: dataPost
                            })
                        }
                    }
                })
            },
            fail(res) {
                wx.showToast({
                    title: '选择图片失败',
                    icon: 'none'
                })
            }
        })
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 输入框输入
     */
    setInputValue: function (e) {
        let page = this, data = page.data.data, name = e.currentTarget.dataset.name
        data[name] = e.detail.value
        page.setData({
            data: data
        })
    },

    /**
     * 提交认证
     */
    authAction: function () {
        let page = this, data = page.data.data, isAuth = page.data.isAuth, authId = page.data.authId
        if (isAuth) {
            app.api.userAuthDataModifyOnlyABle({id: authId,tutor: data.tutor,email: data.email,QQ: data.QQ}, function (res) {
                if (res.code > 0) {
                    wx.showToast({
                      title: res.msg,
                    })
                    setTimeout(function () {
                        wx.navigateBack({
                          delta: 1,
                        })
                    },1000)
                } else {
                    wx.showToast({
                      title: res.msg,
                      icon: 'none'
                    })
                }
            })
        } else {
            if (!data.username) {
                wx.showToast({
                  title: '请输入姓名',
                  icon: 'none'
                })
                return
            }
            if (!data.region) {
                wx.showToast({
                  title: '请选择地区',
                  icon: 'none'
                })
                return
            }
            if (!data.workname) {
                wx.showToast({
                  title: '请输入'+['','学校名称','科研院所名称','企业名称'][data.identity_information],
                  icon: 'none'
                })
                return
            }
            if (!data.working_direction && data.identity_information < 3) {
                wx.showToast({
                  title: '请输入'+['','所在院系','从事方向',''][data.identity_information],
                  icon: 'none'
                })
                return
            }
            if (!data.identity && data.identity_information < 3) {
                wx.showToast({
                  title: '请选择身份',
                  icon: 'none'
                })
                return
            }
            if (!data.working_address && data.identity_information == 3) {
                wx.showToast({
                  title: '请输入工作地址',
                  icon: 'none'
                })
                return
            }
            if (!data.enterprise_number && data.identity_information == 3) {
                wx.showToast({
                  title: '请输入企业税号',
                  icon: 'none'
                })
                return
            }
            if (!data.certificates) {
                wx.showToast({
                  title: '请选择证件',
                  icon: 'none'
                })
                return
            }
            if (!data.tutor && data.identity_information < 3) {
                wx.showToast({
                  title: '请输入导师信息',
                  icon: 'none'
                })
                return
            }
            if (!data.email) {
                // wx.showToast({
                //   title: '请输入邮箱',
                //   icon: 'none'
                // })
                // return
            }
            if (!data.QQ) {
                // wx.showToast({
                //   title: '请输入QQ',
                //   icon: 'none'
                // })
                // return
            }
            if (!data.front_certificate) {
                wx.showToast({
                  title: '请上传正面照',
                  icon: 'none'
                })
                return
            }
            if (!data.reverse_certificate) {
                wx.showToast({
                  title: '请上传反面照',
                  icon: 'none'
                })
                return
            }
            console.log(data)
            app.api.userIdentityAuthAction(data, function (res) {
                console.log(res)
                if (res.code > 0) {
                    wx.showToast({
                      title: res.msg,
                    })
                    app.db.set('element_point_change',1)
                    setTimeout(function () {
                        wx.navigateBack({
                          delta: 1,
                        })
                    },1000)
                } else {
                    wx.showToast({
                      title: res.msg,
                      icon: 'none'
                    })
                }
            })
        }
    }
})