const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        tabActiveId: 0,
        list: [],
        currentIndex: -1
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getCommissionExchangeData()
    },
    /**
     * 选择弹窗
     */
    swichNum(e) {
        const c = e.currentTarget.dataset;
        this.setData({
            currentIndex: c.current, // 更新选中的tab
        });
    },
    /**
     * 选项卡
     */
    tabClick(e) {
        const t = e.currentTarget.dataset;
        this.setData({
            tabActiveId: t.id,
        });
    },
    /**
     * 隐藏tab窗口
     */
    hideWindow() {
        this.setData({
            tabActiveId: 0,
        });
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取数据
     */
    getCommissionExchangeData: function () {
        let page = this
        app.api.getCommissionExchangeData("", function (res) {
            if (res.code > 0) {
                page.setData({
                    list: res.data
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 确认兑换
     */
    exchangeAction: function () {
        let page = this, list = page.data.list, index = page.data.currentIndex
        if (index < 0) {
            wx.showToast({
              title: '请选择需要兑换的积分',
              icon: 'none'
            })
            return
        }
        let id = list[index].id
        app.api.commissionExchangeAction("id="+id, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                app.db.set('element_point_change',1)
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})