const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        id: 0,
        info: [],
        data: {
            user_name: '',
            user_phone: '',
            region: [],
            address: ''
        }
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            id: options.id
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getIntegralMallDetail()
    },
    // 兑换成功-弹窗
    show() {
        wx.showToast({
            title: '兑换成功',
            icon: 'none',
            duration: 1500
        })
    },

    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取产品详情
     */
    getIntegralMallDetail: function () {
        let page = this, id = page.data.id
        app.api.getIntegralMallDetail("id="+id, function (res) {
            if (res.code > 0) {
                page.setData({
                    info: res.data
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 文本框输入
     */
    setInputValue: function (e) {
        let page = this, value = e.detail.value, data = page.data.data, name = e.currentTarget.dataset.name
        data[name] = value
        page.setData({
            data: data
        })
    },

    /**
     * 选择地区
     */
    setRegion: function (e) {
        let page = this, data = page.data.data
        data.region = e.detail.value
        page.setData({
            data: data
        })
    },

    /**
     * 立即兑换
     */
    goExchange: function () {
        let page = this, id = page.data.id, data = page.data.data
        if (!data.user_name) {
            wx.showToast({
              title: '请输入姓名',
              icon: 'none'
            })
            return
        }
        if (!/^1[3456789]\d{9}$/.test(data.user_phone)) {
            wx.showToast({
              title: '请输入正确格式的手机号',
              icon: 'none'
            })
            return
        }
        if (data.region.length == 0) {
            wx.showToast({
              title: '请选择地区',
              icon: 'none'
            })
            return
        }
        if (!data.address) {
            wx.showToast({
              title: '请输入详细地址',
              icon: 'none'
            })
            return
        }
        data.id = id
        let region = data.region, regionDesc = region[0]+region[1]+region[2]
        data.region = regionDesc
        let postStr = "id="+data.id+"&user_name="+data.user_name+"&user_phone="+data.user_phone+"&region="+regionDesc+"&address="+data.address
        app.api.integralMallExchangeAction (postStr, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                app.db.set('element_point_change',1)
                setTimeout (function () {
                    wx.redirectTo({
                        url: '../exchange-record/exchange-record',
                      })
                },1500)
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})