const date = new Date()
const app = getApp()
// const years = []
// const year = date.getFullYear()
const months = []
const days = []
const hours = []

// for (let i = 1990; i <= year; i++) {
//     years.push(i)
// }

for (let i = 1; i <= 12; i++) {
    months.push(i)
}

for (let i = 1; i <= 31; i++) {
    days.push(i)
}

for (let i = 0; i <= 22; i += 2) {
    const toStr = num => num < 10 ? '0' + num : num;
    hours.push(`${toStr(i)}:00-${toStr(i+2)}:00`);
}
Page({

    /**
     * 页面的初始数据
     */
    data: {
        //照片
        imgList: ['../../images/icon-16.png', '../../images/icon-16.png'],
        imgListMaxLength: 9,
        // 选择时间
        // years,
        // year,
        months,
        month: 1,
        days,
        day: 1,
        hours,
        hour: '',
        value: [0, 0, 0],
        selectTime: `1月1日 00:00-02:00`,
        isShowSelectTime: false,
        id: 0,
        info: {},
        data: {
            requirement_title: '',
            detailed_requirements: '',
            demand_picture: [],
            user_name: '',
            phone: '',
            budget_time: '01-01 00:00-02:00',
            code: '',
            email: ''
        },
        config: {},
        time: 60,
        lock_code: false,
        btn_desc: '获取验证码'
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            id: options.id
        })
        this.getServiceDetail()
        this.getUploadConfig()
    },

    /**
     * 发送验证码
     */
    sendCode: function () {
        let page = this, mobile = page.data.data.phone, lock_code = page.data.lock_code
        if (!/^1[3456789]\d{9}$/.test(mobile)) {
            wx.showToast({
              title: '请输入正确格式的手机号',
              icon: 'none'
            })
            return
        }
        if (lock_code) {
            return
        }
        app.api.senSmsCode ({phone: mobile}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                page.timeOut()
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 倒计时
     */
    timeOut: function () {
        let page = this, time = page.data.time
        if (time > 1) {
            time--
            page.setData({
                lock_code: true,
                time: time,
                btn_desc: 'wait '+time+' s'
            })
            page.timeOutSingle = setTimeout (function () {
                page.timeOut()
            },1000)
        } else {
            page.setData({
                lock_code: false,
                time: 60,
                btn_desc: '获取验证码'
            })
            clearTimeout(page.timeOutSingle)
        }
    },

    /**
     * 文本框输入
     */
    setInputValue : function (e) {
        let page = this, name = e.currentTarget.dataset.name, value = e.detail.value, data = page.data.data
        data[name] = value
        page.setData({
            data: data
        })
    },

    /**
     * 获取上传配置
     */
    getUploadConfig: function () {
        let page = this
        app.api.getUploadConfig("", function (res) {
            if (res.code > 0) {
                page.setData({
                    config: res.data
                })
            }
        })
    },

    /**
     * 上传照片
     */
    selectImages() {
        let page = this, max = page.data.imgListMaxLength, data = page.data.data, numberAble = max - data.demand_picture.length, config = page.data.config
        if (numberAble <= 0) {
            wx.showToast({
              title: '最多只能上传'+max+'图片',
              icon: 'none'
            })
            return
        }
        if (!config.hasOwnProperty('policy')) {
            wx.showToast({
              title: '上传配置错误',
              icon: 'none'
            })
            return
        }

        wx.chooseImage({
            count: numberAble,
            sizeType: ['original', 'compressed'],
            sourceType: ['album', 'camera'],
            success(res) {
                let tempFilePaths = res.tempFilePaths;

                for (let item of tempFilePaths) {
                    wx.showLoading({
                    title: '上传中...',
                    icon: 'loading',
                    mask: true
                    })
                    let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png'
                    wx.uploadFile({
                        url: config.host,
                        filePath: item,
                        name: 'file',
                        formData: {
                            key: key,
                            policy: config.policy, // 输入你获取的的policy
            
                            OSSAccessKeyId: config.OSSAccessKeyId, // 输入你的AccessKeyId
            
                            success_action_status: '200', // 让服务端返回200,不然，默认会返回204
            
                            signature: config.Signature, // 输入你获取的的signature
            
                        },
                        success(res) {
                            wx.hideLoading();
                            if (res.statusCode == 200) {
                                data.demand_picture.push(config.host + '/' + key)
                                page.setData({
                                    data: data
                                })
                            }
                        }
                    })
                }
            },
            fail(res) {
                wx.showToast({
                    title: '选择图片失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 删除指定图片
     */
    removeImg(e) {
        let page = this, data = page.data.data, imgList = data.demand_picture ,currentIndex = e.target.dataset.index;
        let newImgList = imgList.filter((data, index) => index !== currentIndex);
        data.demand_picture = newImgList
        this.setData({
            data: data
        })
    },

    // 触发选择时间
    bindSelectTimeChange(e) {
        const val = e.detail.value;
        this.setData({
            // year: this.data.year,
            month: this.data.months[val[0]],
            day: this.data.days[val[1]],
            hour: this.data.hours[val[2]],
            value: val,
        });
    },

    // 显示选择时间
    showSelectTime() {
        this.setData({
            isShowSelectTime: true,
        });
    },

    // 取消选择时间
    hideSelectTime() {
        this.setData({
            isShowSelectTime: false,
        });
    },

    // 确定选择时间
    confirmSelectTime() {
        let page = this, data = page.data.data
        const {
            // year,
            month,
            day,
            hour
        } = this.data;
        data.budget_time =  page.numberFormat(month) + '-' + page.numberFormat(day) + ' ' + hour
        this.setData({
            isShowSelectTime: false,
            selectTime: `${month}月${day}日 ${hour}`,
            data: data
        })
    },

    /**
     * 数字格式化
     */
    numberFormat: function (num) {
        return num < 10 ? '0'+num : num
    },

    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },

    /**
     * 获取产品详情
     */
    getServiceDetail: function () {
        let page = this
        app.api.getServiceDetail("id="+page.data.id, function (res) {
            console.log(res)
            if (res.code > 0) {
                page.setData({
                    info: res.data
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 确认下单
     */
    confirmOrder: function () {
        let page = this, id = page.data.id, data = page.data.data, year = new Date().getFullYear()
        data.commodity_id = id
        if (!data.requirement_title) {
            wx.showToast({
              title: '请输入需求标题',
              icon: 'none'
            })
            return
        }
        if (!data.detailed_requirements) {
            wx.showToast({
              title: '请输入详细需求',
              icon:'none'
            })
            return
        }
        if (data.demand_picture.length == 0) {
            wx.showToast({
              title: '请上传需求照片',
              icon: 'none'
            })
            return
        }
        if (!data.user_name) {
            wx.showToast({
              title: '请输入姓名',
              icon: 'none'
            })
            return
        }
        if (!data.phone) {
            wx.showToast({
              title: '请输入手机号',
              icon: 'none'
            })
            return
        }
        if (!data.code) {
            wx.showToast({
              title: '请输入验证码',
              icon: 'none'
            })
            return
        }
        if (!data.email) {
            wx.showToast({
              title: '请输入邮箱',
              icon: 'none'
            })
            return
        }
        if (!data.budget_amount) {
            // wx.showToast({
            //   title: '请输入预算金额',
            //   icon: 'none'
            // })
            // return
        }
        if (!data.budget_time) {
            // wx.showToast({
            //   title: '请选择预算时间',
            //   icon: 'none'
            // })
            // return
        }
        data.budget_time = year + '-' + data.budget_time
console.log(data)        
        app.api.userServiceCreateOrder(data, function (res) {
            console.log(res)
            
            if (res.code > 0) {
                wx.showToast({
                    title: res.msg,
                })
                app.db.set('element_order_change',1)
                setTimeout(() => {
                    wx.switchTab({
                        url: '../order/order',
                      })
                }, 1000);
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})