const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        pageNow: 1,
        isEnd: false,
        list: [],
        status: ["","待发货","已发货","已完成"]
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.userIntegralMallExchangeRecords()
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        return;
        let page = this, pageNow = page.data.pageNow, isEnd = page.data.isEnd
        if (isEnd) {
            wx.showToast({
              title: '没有更多了...',
              icon: 'none'
            })
            return
        }
        pageNow++
        page.setData({
            pageNow: pageNow
        })
        page.userIntegralMallExchangeRecords()
    },

    /**
     * 获取列表数据
     */
    userIntegralMallExchangeRecords: function () {
        let page = this, pageNow = page.data.pageNow, listNow = page.data.list
        app.api.userIntegralMallExchangeRecords("page="+pageNow+"&page_szie=10", function (res) {
            console.log(res)
            if (res.code > 0) {
                if (pageNow == 1) {
                    listNow = []
                }
                let list = res.data
                if (list.length==0) {
                    page.setData({
                        isEnd: true
                    })
                    if (pageNow == 1) {
                        wx.showToast({
                          title: '暂无相关兑换记录',
                          icon: 'none'
                        })
                        return
                    }
                } else {
                    for (let i=0; i<list.length; i++) {
                        listNow.push(list[i])
                    }
                }

                page.setData({
                    list: listNow
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 确认收货
     */
    confirmOrder: function (e) {
        let {id, index} = e.currentTarget.dataset, page = this, list = page.data.list
        wx.showModal({
          title: '提示',
          content: '确认收货吗',
          confirmColor: '#2B86FF',
          success(res) {
              if (res.confirm) {
                  app.api.integralMallConfirmShouHUo("id="+id, function (res) {
                    if (res.code > 0) {
                        page.setData({
                            [`list[${index}].exchange_status`]: 3
                        })
                    } else {
                        wx.showToast({
                          title: res.msg,
                          icon: 'none'
                        })
                    }
                  })
              }
          }
        })
    }
})