const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        texts: "",
        min: 0, //最少字数
        max: 200, //最多字数 (根据自己需求改变) 
        navbarHeight: 0,
        currentTab: 1,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
    },
    //字数限制  
    inputs: function (e) {
        // 获取输入框的内容
        var value = e.detail.value;
        // 获取输入框内容的长度
        var len = parseInt(value.length);
        //最少字数限制
        // if (len < this.data.min) {
        //     this.setData({
        //         texts: "加油，至少要输入5个字哦"
        //     })
        // } else if (len >= this.data.min) {
        //     this.setData({
        //         texts: " "
        //     })
        // }
        //最多字数限制
        if (len > this.data.max) return;
        // 当输入框内容的长度大于最大长度限制（max)时，终止setData()的执行
        this.setData({
            texts: value,
            currentWordNumber: len //当前字数  
        });
    },
    /**
     * 选择tag 
     */
    switchNav(e) {
        const current = e.currentTarget.dataset.current;
        this.setData({
            currentTab: current, // 更新选中的tab
        });
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 提交反馈
     */
    feedAction: function () {
        let page = this, feedback_type = page.data.currentTab, feedback_data = page.data.texts
        if (!feedback_data) {
            wx.showToast({
              title: '请输入反馈内容',
              icon: 'none'
            })
            return
        }
        app.api.userFeedQuestion({feedback_type: feedback_type, feedback_data: feedback_data}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})