// pages/feedback/feedback.js
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        texts: "",
        min: 0, //最少字数
        max: 200, //最多字数 (根据自己需求改变) ,
        id: 0,
        content: ''
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            id: options.id
        })
    },
    //字数限制  
    setContent: function (e) {
        // 获取输入框的内容
        var value = e.detail.value;
        // 获取输入框内容的长度
        var len = parseInt(value.length);
        //最少字数限制
        // if (len < this.data.min) {
        //     this.setData({
        //         texts: "加油，至少要输入5个字哦"
        //     })
        // } else if (len >= this.data.min) {
        //     this.setData({
        //         texts: " "
        //     })
        // }
        //最多字数限制
        if (len > this.data.max) return;
        // 当输入框内容的长度大于最大长度限制（max)时，终止setData()的执行
        this.setData({
            currentWordNumber: len,
            content: e.detail.value 
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 提交反馈
     */
    feedAction: function () {
        let page = this, id = page.data.id, content = page.data.content
        if (!content) {
            wx.showToast({
              title: '请输入反馈内容',
              icon: 'none'
            })
            return
        }
        app.api.orderFeedQuestion({id: id, problem: content}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})