const util = require('../../utils/util');
const app = getApp();
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        point: 0,
        list: [],
        pageNow: 1,
        isEnd: false,
        uid: 0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            uid: app.db.get('element_uid')
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getIntegralMallList()
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        let page = this, element_point_change = app.db.get('element_point_change')
        if (element_point_change) {
            page.changeIntegral()
        }
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {
        this.setData({
            pageNow: 1,
            isEnd: false
        })
        this.getIntegralMallList()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        let page = this, pageNow = page.data.pageNow, isEnd = page.data.isEnd
        if (isEnd) {
            wx.showToast({
              title: '没有更多了...',
              icon: 'none'
            })
            return
        }
        pageNow++
        page.setData({
            pageNow: pageNow
        })
        page.getIntegralMallList()
    },

    /**
     * 获取列表数据
     */
    getIntegralMallList: function () {
        let page = this, pageNow = page.data.pageNow, listNow = page.data.list     
        app.api.getIntegralMallList({page: pageNow, page_size: 10}, function (res) {
            wx.stopPullDownRefresh()
            if (res.code > 0) {
                if (pageNow == 1) {
                    listNow = []
                }
                let list = res.data.list
                if (list.length > 0) {
                    for (let i=0; i<list.length; i++) {
                        listNow.push(list[i])
                    }
                } else {
                    if (pageNow == 1) {
                        listNow = []
                    }
                    page.setData({
                        isEnd: true
                    })
                    wx.showToast({
                      title: '暂无更多数据',
                      icon: 'none'
                    })
                }

                page.setData({
                    point: res.data.user_integral,
                    list: listNow
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 改变积分
     * @param {*} e 
     */
    changeIntegral: function () {
        let page = this
        app.api.getIntegralMallList({page: 1,page_szie: 10}, function (res) {
            if (res.code > 0) {
                page.setData({
                    point: res.data.user_integral,
                })
            }
        })
    },

    /**
     * 产品详情
     */
    goodsDetail: function (e) {
        wx.navigateTo({
          url: '../exchange-details-page/exchange-details-page?id='+e.currentTarget.dataset.id,
        })
    },

    /**
     * 兑换记录
     */
    exchangeRecords: function () {
        wx.navigateTo({
          url: '../exchange-record/exchange-record',
        })
    }
})