const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        isShow: false,
        uid: 0,
        poster: '../../images/icon-7.png'
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            uid: app.db.get('element_uid')
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getUserInvitePoster()
    },
    /**
     * 显示
     */
    show() {
        this.setData({
            isShow: true
        })
    },
    /**
     * 关闭
     */
    hideWindow() {
        this.setData({
            isShow: false
        })
    },
     /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取推广海报
     */
    getUserInvitePoster: function () {
        let page = this, uid = page.data.uid
        app.api.getUserInvitePoster({id: uid}, function (res) {
            if (res.code > 0) {
                page.setData({
                    poster: res.data,
                    isShow: true
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 保存海报
     */
    downloadPoster: function () {
        let image = this.data.poster
        if (image) {
            wx.getSetting({
                success(res) {
                    if (!res['authSetting']['scope.writePhotosAlbum']) {
                        //引导用户授权
                        wx.authorize({
                            scope: 'scope.writePhotosAlbum',
                            success() {
                                wx.downloadFile({
                                    url: image,
                                    success(response) {
                                        if (response.statusCode == 200) {
                                            wx.saveImageToPhotosAlbum({
                                                filePath: response.tempFilePath,
                                                success(res_) {
                                                    wx.showToast({
                                                        title: '保存图片成功',
                                                    })
                                                },
                                                fail(res_) {
                                                    wx.showToast({
                                                        title: '保存图片失败',
                                                        icon: 'none'
                                                    })
                                                }
                                            })
                                        }
                                    },
                                    fail(response) {
                                        wx.showToast({
                                            title: '接口调用失败',
                                            icon: 'none'
                                        })
                                    }
                                })
                            }
                        })
                    } else {
                        //已授权，直接下载
                        wx.downloadFile({
                            url: image,
                            success(response) {
                                if (response.statusCode == 200) {
                                    wx.saveImageToPhotosAlbum({
                                        filePath: response.tempFilePath,
                                        success(res_) {
                                            wx.showToast({
                                                title: '保存图片成功',
                                            })
                                        },
                                        fail(res_) {
                                            wx.showToast({
                                                title: '保存图片失败',
                                                icon: 'none'
                                            })
                                        }
                                    })
                                }
                            },
                            fail(response) {
                                wx.showToast({
                                    title: '接口调用失败',
                                    icon: 'none'
                                })
                            }
                        })
                    }
                }
            })
        }
    },

    /**
     * 活动规则
     */
    activityRule: function () {
        wx.navigateTo({
          url: '../activity-rule/activity-rule',
        })
    }
})