const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        currentTab: 0,
        tabActiveId: 1,
        //服务规格
        items: [{
                name: '0',
                titles: '服务合同',
                checked: true,
                msg: '如需服务合同，请勾选，我们将提供清单'
            },
            {
                name: '1',
                titles: '测试清单',
                checked: true,
                msg: '如需测试清单，请勾选，我们将提供清单'
            },
            {
                name: '2',
                titles: '测试结果',
                checked: false,
                msg: '如需测试结果，请勾选，我们将提供清单'
            },
        ],
        info: {
            invoice_type: 1,        //发票类型（1为电子发票，2为纸质发票）
            invoice_header: 1,      //发票抬头（1为公司，2为个人）
            company_name: '',
            company_number: '',
            user_name: '',
            recipient_name: '',
            recipient_phone: '',
            region: '',
            address: '',
            service_contract: 1,
            test_list: 1,
            test_result: 1,
            email: ''
        },
        order_id: 0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        if (options.hasOwnProperty('order_id')) {
            this.setData({
                order_id: options.order_id
            })
        }
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
    },
    /**
     * 选择发票类型
     */
    switchNav(e) {
        let page = this, current = e.currentTarget.dataset.current;
        page.setData({
            [`info.invoice_type`]: current
        })
    },

    /**
     * 发票抬头
     */
    tabClick(e) {
        let page = this, d = e.currentTarget.dataset;
        page.setData({
            [`info.invoice_header`]: d.id
        })
    },
    /**
     *  服务规格
     */
    checkChange: function (e) {
        var items = this.data.items;
        var checkArr = e.detail.value;
        for (var i = 0; i < items.length; i++) {
            if (checkArr.indexOf(i + "") != -1) {
                items[i].checked = true;
            } else {
                items[i].checked = false;
            }
        }
        this.setData({
            items: items,
        })
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 选择地区
     */
    setRegion: function (e) {
        let value = e.detail.value
        this.setData({
            [`info.region`]: value[0]+value[1]+value[2]
        })
    },

    /**
     * 输入框输入
     */
    setInputValue: function (e) {
        let page = this, name = e.currentTarget.dataset.name, info = page.data.info
        info[name] = e.detail.value
        page.setData({
            info: info
        })
    },

    /**
     * 添加发票
     */
    userInvoiceAdd: function () {
        let page = this, info = page.data.info, items = page.data.items, order_id = page.data.order_id
        if (!order_id) {
            wx.showToast({
              title: '订单参数错误',
              icon: 'none'
            })
            return
        }
        info.order_id = order_id
        info.service_contract = items[0].checked ? 1 : 2
        info.test_list = items[1].checked ? 1 : 2
        info.test_result = items[2].checked ? 1 : 2
console.log(info);
        app.api.userInvoiceAdd(info, function (res) {
console.log(res)
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})