const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        cate_id: 0,
        pageNow: 1,
        isEnd: false,
        list: [],
        category: []
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            cate_id: options.cate_id
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getIndexCategory()
        this.getcateServiceList()
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    //跳转服务详情
    productDetails(e) {
        wx.navigateTo({
            url: '../product-details/product-details?id='+e.currentTarget.dataset.id,
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        let page = this, pageNow = page.data.pageNow, isEnd = page.data.isEnd
        if (isEnd) {
            wx.showToast({
              title: '没有更多了...',
              icon: 'none'
            })
            return
        }
        pageNow++
        page.setData({
            pageNow: pageNow
        })
        page.getcateServiceList()
    },

    /**
     * 获取列表数据
     */
    getcateServiceList: function () {
        let page = this, pageNow = page.data.pageNow, listNow = page.data.list, cate_id = page.data.cate_id
        app.api.getcateServiceList('page='+pageNow+'&page_size=10&cate_id='+cate_id, function (res) {
            console.log(res)
            wx.stopPullDownRefresh()
            if (res.code > 0) {
                if (pageNow == 1) {
                    listNow = []
                }
                if (res.data.length == 0) {
                    if (pageNow == 1) {
                        page.setData({
                            list: []
                        })
                    }
                    page.setData({
                        isEnd: true
                    })
                    wx.showToast({
                      title: '暂无更多数据',
                      icon: 'none'
                    })
                    return
                }
                let list = res.data
                for (let i=0; i<list.length; i++) {
                    listNow.push(list[i])
                }

                page.setData({
                    list: listNow
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 获取顶部分类
     */
    getIndexCategory: function () {
        let page = this
        app.api.getIndexCategory({page: 1, page_size: 10}, function (res) {
            if (res.code > 0) {
                page.setData({
                    category: res.data
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 分类切换
     */
    switchCate: function (e) {
        let page = this, {id, index} = e.currentTarget.dataset
        page.setData({
            pageNow: 1,
            isEnd: false,
            cate_id: id
        })
        page.getcateServiceList()
    }
})