const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        scrollTop: 0,
        isLogin: false,
        info: {
            balance: 0,
            integral: 0
        },
        percent: 0,
        code: ''
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        })
        let element_session_key = app.db.get('element_session_key')
        if (element_session_key) {
            this.setData({
                isLogin: true
            })
            this.getUserInfo()
        }
    },

    onShow: function () {
        let element_session_key = app.db.get('element_session_key')
        if (element_session_key) {
            if (!this.data.isLogin) {
                this.setData({
                    isLogin: true
                })
            }
            this.getUserInfo()
        }
        let point_change = app.db.get('element_point_change')
        if (point_change) {
            app.db.del('element_point_change')
            this.getUserInfo()
        }
    },

    //获取用户信息
    getUserInfo: function () {
        let page = this
        app.api.getUserInfo({}, function (res) {
            console.log(res)
            if (res.code > 0) {
                page.setData({
                    isLogin: true,
                    info: res.data,
                    percent: parseInt(res.data.experience) / parseInt(res.data.empirical_max) * 100
                })
                app.db.set('element_user_id', res.data.id)
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none'
                })
            }
        })
    },

    //
    onPageScroll(e) {
        this.setData({
            scrollTop: e.scrollTop,
        });
    },
    //跳转我的余额
    balanceDetails() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../balance-details/balance-details',
        })
    },
    //跳转我的积分
    pointsDetails() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../points-details/points-details',
        })
    },
    //跳转推荐有礼
    inviteFriends() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../invite-friends/invite-friends',
        })
    },
    //跳转申请成为正式员工
    applyToBeAnEmployee() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        if (this.data.info.regular_employee == 1) {
            wx.navigateTo({
              url: '../successful-application/successful-application',
            })
        } else {
            wx.navigateTo({
                url: '../apply-to-be-an-employee/apply-to-be-an-employee',
            })
        }
    },
    //跳转积分商城
    integralMall() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../integral-mall/integral-mall',
        })
    },
    //跳转其他功能
    otherFeatures() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../other-features/other-features',
        })
    },
    //跳转认证信息
    authenticationInformation() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        // if (this.data.info.authentication_status == 2) {
        //     wx.showToast({
        //       title: '您已完成身份认证',
        //       icon: 'none'
        //     })
        //     return
        // }
        wx.navigateTo({
            url: '../authentication-information/authentication-information?status='+this.data.info.authentication_status,
        })
    },
    //跳转常见问题
    commonProblem() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../common-problem/common-problem',
        })
    },
    //跳转推荐人
    referees() {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../referees/referees',
        })
    },

    //拨打客服电话
    makeMobileCall: function () {
        wx.makePhoneCall({
            phoneNumber: this.data.info.customer_phone,
            success(res) {
                console.log(res)
            },
            fail(res) {
                console.log(res)
            }
        })
    },

    /**
     * 退出登录
     */
    loginOut: function () {
        let page = this
        wx.showModal({
            title: '提示',
            content: '确认退出登录吗',
            confirmColor: '#2B86FF',
            success(res) {
                if (res.confirm) {
                    page.setData({
                        isLogin: false,
                        info: {
                            balance: 0,
                            integral: 0,
                            invitation_code: ''
                        }
                    })
                    app.db.clear()
                }
            }
        })
    },

    /**
     * 获取登录code
     */
    getCode: function () {
        let page = this
        wx.login({
            success: function (res) {
                if (res.code) {
                    page.setData({
                        code: res.code
                    })
                } else {
                    wx.showToast({
                        title: '登录失败',
                        icon: 'none'
                    })
                }
            },
            fail: function () {
                wx.showToast({
                    title: '登录失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 授权登录
     */
    getUserProfile: function () {
        let page = this,
            invite_id = app.db.get('element_invite_id'),
            pid = invite_id ? invite_id : 0
        page.getCode()
        wx.getUserProfile({
            desc: '授权登录后可操作',
            success(res) {
                let nickName = res.userInfo.nickName,
                    avatarUrl = res.userInfo.avatarUrl
                app.api.login({
                    name: nickName,
                    headimg: avatarUrl,
                    code: page.data.code,
                    pid: pid
                }, function (response) {
                    if (response.code > 0) {
                        app.db.set('element_session_key', response.data, true)
                        app.db.del('element_invite_id')
                        page.getUserInfo()
                    } else {
                        wx.showToast({
                            title: response.msg,
                            icon: 'none'
                        })
                    }
                })
            },
            fail(res) {
                wx.showToast({
                    title: '获取用户信息失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 修改信息
     */
    modifyInfo: function () {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../modify-mine/modify-mine',
        })
    },

    /**
     * 实名认证信息
     */
    realAuthInfo: function () {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../real-name-authentication-msg/real-name-authentication-msg',
        })
    },

    /**
     * 实名认证操作
     */
    realAuthAction: function () {
        if (!this.data.isLogin) {
            wx.showToast({
                title: '请登陆后操作',
                icon: 'none'
            })
            return
        }
        wx.navigateTo({
            url: '../real-name-authentication/real-name-authentication',
        })
    }
})