// pages/order-details/order-details.js
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        isShow: false,
        id: 0,
        index: -1,
        info: [],
        timeArr: [0,0,0],
        remaining_time: 0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            id: options.id,
            index: options.index
        })
        this.getUserOrderDetail()
    },
    /**
     * 显示催进度弹窗
     */
    show() {
        this.setData({
            isShow: true
        })
    },
    /**
     * 关闭
     */
    hideWindow() {
        this.setData({
            isShow: false
        })
    },
    del() {
        wx.showModal({
            title: '提示',
            content: '确认删除',
            success(res) {
                if (res.confirm) {
                    console.log('用户点击确定')
                } else if (res.cancel) {
                    console.log('用户点击取消')
                }
            }
        })
    },
    //跳转历史进度
    historicalProgress() {
        wx.navigateTo({
            url: '../historical-progress/historical-progress',
        })
    },
    //跳转查看成果
    lookResults() {
        wx.navigateTo({
            url: '../look-results/look-results',
        })
    },
    //跳转问题反馈
    feedback() {
        wx.navigateTo({
            url: '../feedback/feedback',
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取订单信息
     */
    getUserOrderDetail: function () {
        let page = this, id = page.data.id
        app.api.getUserOrderDetail({id: id}, function (res) {
            console.log(res)
            if (res.code > 0) {
                page.setData({
                    info: res.data
                })
                if (res.data.order_info.hasOwnProperty('remaining_time')) {
                    page.setData({
                        remaining_time: res.data.order_info.remaining_time
                    })
                    setTimeout (function () {
                        page.timeOutAction()
                    },10)
                }
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 取消订单
     */
    orderCancel: function () {
        let page = this, index = page.data.index, id = page.data.id, info = page.data.info
        wx.showModal({
          title: '提示',
          content: '确认取消该订单吗',
          confirmColor: '#00A7FF',
          success(res) {
              if (res.confirm) {
                app.api.changeOrderStatus({id: id, payment_status: 5}, function (res) {
                    if (res.code > 0) {
                        wx.showToast({
                          title: res.msg,
                        })
                        info.order_info.payment_status = 5
                        page.setData({
                            info: info
                        })
                        app.db.set('element_order_change_status',{index: index, id: id, status: 5})
                    } else {
                        wx.showToast({
                          title: res.msg,
                          icon: 'none'
                        })
                    }
                })
              }
          }
        })
    },

    /**
     * 删除订单
     */
    orderDel: function () {
        let page = this, id = page.data.id, index = page.data.index
        wx.showModal({
          title: '提示',
          content: '确认删除此订单吗',
          confirmColor: '#00A7FF',
          success(res) {
              if (res.confirm) {
                  app.api.userOrderDel ({id: id}, function (res) {
                      if (res.code > 0) {
                        wx.showToast({
                          title: res.msg,
                        })
                        app.db.set('element_order_change_status',{index: index, id: id, status: -1})
                        setTimeout(function () {
                            wx.navigateBack({
                              delta: 1,
                            })
                        },1000)
                      } else {
                          wx.showToast({
                            title: res.msg,
                            icon: 'none'
                          })
                      }
                  })
              }
          }
        })
    },

    /**
     * 查看成果
     */
    orderLookResult: function () {
        wx.navigateTo({
          url: '../look-results/look-results?id='+this.data.id+'&type=1',
        })
    },

    /**
     * 确认完成:确认是修改状态还是确认收货： 确认收货方法  orderConfirmShouHuo
     */
    orderFinish: function () {
        let page = this, index = page.data.index, id = page.data.id, info = page.data.info
        wx.showModal({
          title: '提示',
          content: '确认完成该订单吗',
          confirmColor: '#00A7FF',
          success(res) {
              if (res.confirm) {
                app.api.orderConfirmShouHuo({id: id}, function (res) {
                    if (res.code > 0) {
                        wx.showToast({
                          title: res.msg,
                        })
                        info.order_info.payment_status = 4
                        page.setData({
                            info: info
                        })
                        app.db.set('element_order_change_status',{index: index, id: id, status: 4})
                    } else {
                        wx.showToast({
                          title: res.msg,
                          icon: 'none'
                        })
                    }
                })
              }
          }
        })
    },

    /**
     * 查看合同
     */
    orderLookHeTong: function () {
        wx.navigateTo({
            url: '../look-results/look-results?id='+this.data.id+'&type=2',
        })
    },

    /**
     * 催进度
     */
    orderJinDu: function () {
        let id = this.data.id
        app.api.orderSchedule ({id: id}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 历史进度
     */
    orderHistory: function () {
        wx.navigateTo({
          url: '../historical-progress/historical-progress?id='+this.data.id,
        })
    },

    /**
     * 问题反馈
     */
    orderFeedBack: function () {
        wx.navigateTo({
          url: '../feedback/feedback?id='+this.data.id,
        })
    },

    /**
     * 时间倒计时
     */
    timeOutAction: function () {
        let page = this, end_time = page.data.remaining_time, time_last = end_time, timeArr = [0, 0, 0]
console.log(end_time)
        if (time_last > 0) {
          time_last--  
          let hour = parseInt(time_last / (60 * 60));
          let minute = parseInt(time_last % (60 * 60 * 24) % 3600 / 60);
          let seconds = parseInt(time_last % (60 * 60 * 24) % 3600 % 60);
          timeArr = [
            page.timeFormat(hour),
            page.timeFormat(minute),
            page.timeFormat(seconds)
          ];
          let timeIntervalSingle = setTimeout(function () {
            page.timeOutAction()
          }, 1000)
          page.setData({
            remaining_time: time_last,
            timeArr: timeArr,
            timeIntervalSingle
          })
        } else {
          timeArr = [0, 0, 0];
          clearTimeout(page.data.timeIntervalSingle)
          page.setData({
            remaining_time: 0,
            timeArr: timeArr
          })
        }
    },

  /** 
   * 时间显示小于10的格式化函数
   */
  timeFormat(param) {
    return param < 10 ? '0' + param : param;
  },

  /**
   * 发票
   */
  getPiao: function () {
      wx.navigateTo({
        url: '../invoice-information/invoice-information?order_id='+this.data.id,
      })
  }
})