// pages/my/my-order/my-order.js
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        //选项卡
        status: 0,
        isLogin: false,
        isLoginShow: false,
        code: '',
        list: []
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        let element_session_key = app.db.get('element_session_key'), page = this
        if (!element_session_key) {
            page.setData({
                isLoginShow: true
            })
        } else {
            page.setData({
                isLogin: true
            })
            page.getUserOrderList()
        }
    },

    onShow: function () {
        let element_session_key = app.db.get('element_session_key'), page = this, element_order_change = app.db.get('element_order_change')
        if (element_session_key) {
            page.setData({
                isLogin: true
            })
            if (page.data.isLoginShow) {
                page.setData({
                    isLoginShow: false
                })
                page.getUserOrderList()
            }
            
            if (element_order_change) {
                app.db.del('element_order_change')
                page.getUserOrderList()
            }
        } else {
            page.setData({
                isLoginShow: true,
                list: []
            })
        }

        let element_order_change_status = app.db.get('element_order_change_status')
        if (element_order_change_status) {
            let index = element_order_change_status.index, status = element_order_change_status.status
            if (index >= 0) {
                let list = page.data.list, statusOrder = page.data.status
                if (status < 0) {
                    //删除订单
                    let listNew = list.filter((item, index_) => index != index_)
                    page.setData({
                        list: listNew
                    })
                } else {
                    if (statusOrder != 0) {
                        let listNew = list.filter((item, index_) => index != index_)
                        page.setData({
                            list: listNew
                        })
                    } else {
                        page.setData({
                            [`list[${index}].payment_status`]: status
                        })
                    }
                }
            }
            app.db.del('element_order_change_status')
        }
    },

    /**
     * 选项卡
     */
    tabClick(e) {
        let page = this, status = page.data.status, d = e.currentTarget.dataset.id;
        if (status == d) {
            return
        }
        page.setData({
            status: d
        })
        page.getUserOrderList()
    },
    //跳转订单详情
    orderDetails(e) {
        if (!this.data.isLogin) {
            this.setData({
                isLoginShow: true
            })
            return
        }
        wx.navigateTo({
            url: '../order-details/order-details?id='+e.currentTarget.dataset.id+'&index='+e.currentTarget.dataset.index,
        })
    },

    /**
     * 获取登录code
     */
    getCode: function () {
        let page = this
        wx.login({
            success: function (res) {
                if (res.code) {
                    page.setData({
                        code: res.code
                    })
                } else {
                    wx.showToast({
                        title: '登录失败',
                        icon: 'none'
                    })
                }
            },
            fail: function () {
                wx.showToast({
                    title: '登录失败',
                    icon: 'none'
                })
            }
        })
    },

    //授权获取用户信息
    getUserProfile: function () {
        let page = this, invite_id = app.db.get('element_invite_id'), pid = invite_id ? invite_id : 0
        page.getCode()
        page.setData({
            isLoginShow: false
        })
        wx.getUserProfile({
            desc: '授权登录后可操作',
            success(res) {
                let nickName = res.userInfo.nickName, avatarUrl = res.userInfo.avatarUrl
                app.api.login({name: nickName, headimg: avatarUrl, code: page.data.code, pid: pid}, function (response) {  
                    if (response.code > 0) {
                        page.setData({
                            isLogin: true
                        })
                        app.db.set('element_session_key',response.data, true)
                        app.db.del('element_invite_id')
                        page.getUserOrderList()
                        if (!app.db.get('element_user_id')) {
                            page.getUserInfo()
                        }
                    } else {
                        wx.showToast({
                          title: response.msg,
                          icon: 'none'
                        })
                    }
                })
            },
            fail(res) {
                wx.showToast({
                    title: '获取用户信息失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 获取用户信息
     */
    getUserInfo: function () {
        app.api.getUserInfo({}, function (res) {
            if (res.code > 0) {
                if (res.data.hasOwnProperty('id')) {
                    app.db.set('element_user_id', res.data.id)
                }
            }
        })
    },

    /**
     * 获取订单列表
     */
    getUserOrderList: function () {
        let page = this, isLogin = page.data.isLogin, status = page.data.status
        if (!isLogin) {
            page.setData({
                isLoginShow: true
            })
            return
        }
        app.api.getUserOrderList({payment_status: status}, function (res) {
            console.log(res)
            if (res.code > 0) {
                page.setData({
                    list: res.data
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 取消订单
     */
    orderCancel: function (e) {
        let page = this, index = e.currentTarget.dataset.index, list = page.data.list
        wx.showModal({
          title: '提示',
          content: '确认取消该订单吗',
          confirmColor: '#00A7FF',
          success(res) {
              if (res.confirm) {
                app.api.changeOrderStatus({id: list[index].id, payment_status: 5}, function (res) {
                    if (res.code > 0) {
                        wx.showToast({
                          title: res.msg,
                        })
                        let listNew = list.filter((item, index_) => index != index_)
                        page.setData({
                            list: listNew
                        })
                    } else {
                        wx.showToast({
                          title: res.msg,
                          icon: 'none'
                        })
                    }
                })
              }
          }
        })
    },

    /**
     * 支付
     */
    orderPayAgain: function (e) {
        let page = this, list = page.data.list, {id, index} = e.currentTarget.dataset, status = page.data.status
        
        wx.showModal({
            title: '提示',
            content: '确认订单已支付吗',
            confirmColor: '#00A7FF',
            success(res) {
                if (res.confirm) {
                  app.api.changeOrderStatus({id: list[index].id, payment_status: 2}, function (res) {
                      if (res.code > 0) {
                          wx.showToast({
                            title: res.msg,
                          })
                          if(status > 0) {
                            let listNew = list.filter((item, index_) => index != index_)
                            page.setData({
                                list: listNew
                            })
                          } else {
                            page.setData({
                                [`list[${index}].payment_status`]: 2
                            })
                          }
                      } else {
                          wx.showToast({
                            title: res.msg,
                            icon: 'none'
                          })
                      }
                  })
                }
            }
        })
    },

    /**
     * 查看成果
     */
    lookResult: function (e) {
        let id = e.currentTarget.dataset.id
        wx.navigateTo({
          url: '../look-results/look-results?id='+id+'&type=1',
        })
    },

    /**
     * 确认完成:确认收货方法  orderConfirmShouHuo
     */
    confirmFinish: function (e) {
        let page = this, list = page.data.list, {id, index} = e.currentTarget.dataset, status = page.data.status
        wx.showModal({
            title: '提示',
            content: '确认完成该订单吗',
            confirmColor: '#00A7FF',
            success(res) {
                if (res.confirm) {
                  app.api.orderConfirmShouHuo({id: id}, function (res) {
                      if (res.code > 0) {
                          wx.showToast({
                            title: res.msg,
                          })
                          if (status > 0) {
                            let listNew = list.filter((item, index_) => index != index_)
                            page.setData({
                                list: listNew
                            })
                          } else {
                            page.setData({
                                [`list[${index}].payment_status`]: 4
                            })
                          }
                      } else {
                          wx.showToast({
                            title: res.msg,
                            icon: 'none'
                          })
                      }
                  })
                }
            }
        })
    },

    /**
     * 查看合同
     */
    lookHeTong: function (e) {
        let id = e.currentTarget.dataset.id
        wx.navigateTo({
            url: '../look-results/look-results?id='+id+'&type=2',
          })
    },

    /**
     * 催进度
     */
    waringJinDu: function (e) {
        let id = e.currentTarget.dataset.id
        app.api.orderSchedule ({id: id}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 历史进度
     */
    historyList: function (e) {
        let id = e.currentTarget.dataset.id
        wx.navigateTo({
          url: '../historical-progress/historical-progress?id='+id,
        })
    },

    /** 
     * 隐藏弹窗
     */
    hideEmpower: function () {
        this.setData({
            isLoginShow: false
        })
    }
})