const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        uid: 0,
        list: [],
        pageNow: 1,
        isEnd: false,
        point: 0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            uid: app.db.get('element_uid')
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getPointList()
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    //跳转佣金兑换
    commissionExchange() {
        wx.navigateTo({
            url: '../commission-exchange/commission-exchange',
        })
    },
    //跳转积分规则
    integralRules() {
        wx.navigateTo({
            url: '../integral-rules/integral-rules',
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        let point_change = app.db.get('element_point_change')
        if (point_change) {
            this.getPointList()
        }
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取列表数据
     */
    getPointList: function () {
        let page = this, uid = page.data.uid, pageNow = page.data.pageNow, listNow = page.data.list
        app.api.getPointList({id: uid}, function (res) {
            if (res.code > 0) {
                if (pageNow == 1) {
                    listNow = []
                }
                let list = res.data.list
                if (list.length > 0) {
                    for (let i=0; i<list.length; i++) {
                        listNow.push(list[i])
                    }
                }
                page.setData({
                    point: res.data.integral,
                    list: listNow
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})