const util = require('../../utils/util');
const app = getApp()
const WxParse = require('../../wxParse/wxParse.js');
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        //轮播
        currentSwiper: 0,
        id: 0,
        info: []
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            id: options.id
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
        this.getServiceDetail()
    },
    //swiper内容左右滑动切换触发
    swiperChange(e) {
        const current = e.detail.current;
        this.setData({
            currentSwiper: current, // 更新当前选中
        });
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    //跳转下单
    confirmOrder() {
        wx.navigateTo({
            url: '../confirm-order/confirm-order?id='+this.data.id,
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 获取服务详情
     */
    getServiceDetail: function () {
        let page = this, id = page.data.id
        app.api.getServiceDetail ("id="+id, function (res) {
            if (res.code > 0) {
                page.setData({
                    info: res.data
                })
                let article = res.data.service_display
                WxParse.wxParse('article', 'html', article, page,5);
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    }
})