const date = new Date()
// const years = []
// const year = date.getFullYear()
const months = []
const days = []
const hours = []
const app = getApp()
// for (let i = 1990; i <= year; i++) {
//     years.push(i)
// }

for (let i = 1; i <= 12; i++) {
    months.push(i)
}

for (let i = 1; i <= 31; i++) {
    days.push(i)
}

for (let i = 0; i <= 22; i += 2) {
    const toStr = num => num < 10 ? '0' + num : num;
    hours.push(`${toStr(i)}:00-${toStr(i+2)}:00`);
}
Page({

    /**
     * 页面的初始数据
     */
    data: {
        //照片
        imgListMaxLength: 9,
        //选择类别 一级弹窗
        array: [],
        indexCate: '',
        // 选择时间
        // years,
        // year,
        months,
        month: 1,
        days,
        day: 1,
        hours,
        hour: '',
        value: [0, 0, 0],
        selectTime: `1月1日 00:00-02:00`,
        isShowSelectTime: false,

        //发布成功-弹窗
        isShowWindow: false,
        isLogin: false,
        isLoginShow: false,
        code: '',
        dataPost: {
            service_category_id: '',
            requirement_title: '',
            detailed_requirements: '',
            demand_picture: [],
            user_name: '',
            phone: '',
            code: '',
            email: '',
            budget_amount: '',
            budget_time: '01-01 00:00-02:00'
        },
        lock_code: false,
        time: 60,
        btn_desc: '获取验证码',
        lock_action: false,
        config: {}
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.getUploadConfig()
        this.getIndexCategory()
    },

    onShow: function () {
        let element_session_key = app.db.get('element_session_key')
        if (!element_session_key) {
            this.setData({
                isLoginShow: true
            })
        } else {
            this.setData({
                isLoginShow: false,
                isLogin: true
            })
        }
    },

    /**
     * 获取类别
     */
    getIndexCategory: function () {
        let page = this
        app.api.getIndexCategory ({page: 1, page_size: 50}, function (res) {
            if (res.code > 0) {
                page.setData({
                    array: res.data
                })
            }
        })
    },

    /**
     * 获取上传配置
     */
    getUploadConfig: function () {
        let page = this
        app.api.getUploadConfig("", function (res) {
            if (res.code > 0) {
                page.setData({
                    config: res.data
                })
            }
        })
    },

    /**
     * 上传照片
     */
    selectImages() {
        let page = this, max = page.data.imgListMaxLength, data = page.data.dataPost, numberAble = max - data.demand_picture.length, config = page.data.config

        if (numberAble <= 0) {
            wx.showToast({
              title: '最多只能上传'+max+'图片',
              icon: 'none'
            })
            return
        }
        if (!config.hasOwnProperty('policy')) {
            wx.showToast({
              title: '上传配置错误',
              icon: 'none'
            })
            return
        }

        wx.chooseImage({
            count: numberAble,
            sizeType: ['original', 'compressed'],
            sourceType: ['album', 'camera'],
            success(res) {
                let tempFilePaths = res.tempFilePaths;

                for (let item of tempFilePaths) {
                    wx.showLoading({
                    title: '上传中...',
                    icon: 'loading',
                    mask: true
                    })
                    let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png'
                    wx.uploadFile({
                        url: config.host,
                        filePath: item,
                        name: 'file',
                        formData: {
                            key: key,
                            policy: config.policy, // 输入你获取的的policy
            
                            OSSAccessKeyId: config.OSSAccessKeyId, // 输入你的AccessKeyId
            
                            success_action_status: '200', // 让服务端返回200,不然，默认会返回204
            
                            signature: config.Signature, // 输入你获取的的signature
            
                        },
                        success(res) {
                            wx.hideLoading();
                            if (res.statusCode == 200) {
                                data.demand_picture.push(config.host + '/' + key)
                                page.setData({
                                    dataPost: data
                                })
                            }
                        }
                    })
                }
            },
            fail(res) {
                wx.showToast({
                    title: '选择图片失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 删除指定图片
     */
    removeImg(e) {
        let page = this, data = page.data.dataPost, imgList = data.demand_picture ,currentIndex = e.target.dataset.index;
        let newImgList = imgList.filter((data, index) => index !== currentIndex);
        // data.demand_picture = newImgList
        this.setData({
            [`dataPost.demand_picture`]: imgList
        })
    },

    /**
     * 选择类别 一级弹窗
     */
    bindPickerChange: function (e) {
        let page = this, array = page.data.array
        page.setData({
            indexCate: e.detail.value,
            [`dataPost.service_category_id`]: array[e.detail.value].id
        })
    },

    // 触发选择时间
    bindSelectTimeChange(e) {
        const val = e.detail.value;
        this.setData({
            // year: this.data.year,
            month: this.data.months[val[0]],
            day: this.data.days[val[1]],
            hour: this.data.hours[val[2]],
            value: val,
        });
    },

    // 显示选择时间
    showSelectTime() {
        this.setData({
            isShowSelectTime: true,
        });
    },

    // 取消选择时间
    hideSelectTime() {
        this.setData({
            isShowSelectTime: false,
        });
    },

    // 确定选择时间
    confirmSelectTime() {
        let {
            // year,
            month,
            day,
            hour
        } = this.data;
        this.setData({
            isShowSelectTime: false,
            selectTime: `${month}月${day}日 ${hour}`,
            [`dataPost.budget_time`]: this.numberFormat(month) + '-' + this.numberFormat(day) + ' ' + hour
        })
    },

    /**
     * 数字格式化
     */
    numberFormat: function (num) {
        return num < 10 ? '0'+num : num
    },

    // 显示发布成功弹窗
    showWindow() {
        this.setData({
            isShowWindow: true,
        });
    },

    // 关闭发布成功弹窗
    hideWindow() {
        this.setData({
            isShowWindow: false,
        });
    },

    /**
     * 隐藏授权弹窗
     */
    hideEmpower: function () {
        this.setData({
            isLoginShow: false
        })
    },

    /**
     * 邀请好友
     */
    inviteFriends: function () {
        wx.showToast({
          title: '邀请好友',
          icon: 'none'
        })
    },

    /**
     * 获取登录code
     */
    getCode: function () {
        let page = this
        wx.login({
            success: function (res) {
                if (res.code) {
                    page.setData({
                        code: res.code
                    })
                } else {
                    wx.showToast({
                        title: '登录失败',
                        icon: 'none'
                    })
                }
            },
            fail: function () {
                wx.showToast({
                    title: '登录失败',
                    icon: 'none'
                })
            }
        })
    },

    //授权获取用户信息
    getUserProfile: function () {
        let page = this, invite_id = app.db.get('element_invite_id'), pid = invite_id ? invite_id : 0
        page.getCode()
        page.setData({
            isLoginShow: false
        })
        wx.getUserProfile({
            desc: '授权登录后可操作',
            success(res) {
                let nickName = res.userInfo.nickName, avatarUrl = res.userInfo.avatarUrl
                app.api.login({name: nickName, headimg: avatarUrl, code: page.data.code, pid: pid}, function (response) {  
                    if (response.code > 0) {
                        page.setData({
                            isLogin: true
                        })
                        app.db.set('element_session_key',response.data, true)
                        app.db.del('element_invite_id')
                        if (!app.db.get('element_user_id')) {
                            page.getUserInfo()
                        }
                    } else {
                        wx.showToast({
                          title: response.msg,
                          icon: 'none'
                        })
                    }
                })
            },
            fail(res) {
                wx.showToast({
                    title: '获取用户信息失败',
                    icon: 'none'
                })
            }
        })
    },

    /**
     * 获取用户信息
     */
    getUserInfo: function () {
        app.api.getUserInfo({}, function (res) {
            if (res.code > 0) {
                if (res.data.hasOwnProperty('id')) {
                    app.db.set('element_user_id', res.data.id)
                }
            }
        })
    },


    /**
     * 发送验证码
     */
    sendCode: function () {
        let page = this, mobile = page.data.dataPost.phone, lock_code = page.data.lock_code
        if (!/^1[3456789]\d{9}$/.test(mobile)) {
            wx.showToast({
              title: '请输入正确格式的手机号',
              icon: 'none'
            })
            return
        }
        if (lock_code) {
            return
        }
        app.api.senSmsCode ({phone: mobile}, function (res) {
console.log(res)            
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                page.timeOut()
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 倒计时
     */
    timeOut: function () {
        let page = this, time = page.data.time
        if (time > 1) {
            time--
            page.setData({
                lock_code: true,
                time: time,
                btn_desc: time+' s'
            })
            page.timeOutSingle = setTimeout (function () {
                page.timeOut()
            },1000)
        } else {
            page.setData({
                lock_code: false,
                time: 60,
                btn_desc: '获取验证码'
            })
            clearTimeout(page.timeOutSingle)
        }
    },

    /**
     * 输入框输入
     */
    setInputValue: function (e) {
        let page = this, data = page.data.dataPost, name = e.currentTarget.dataset.name
        data[name] = e.detail.value
        page.setData({
            dataPost: data
        })
    },

    /**
     * 发布操作
     */
    goAction: function () {
        let page = this, dataPost = page.data.dataPost, year = new Date().getFullYear()
        dataPost.budget_time = year + '-' + dataPost.budget_time

        if (!dataPost.service_category_id) {
            wx.showToast({
              title: '请选择类别',
              icon: 'none'
            })
            return
        }
        if (!dataPost.requirement_title) {
            wx.showToast({
              title: '请输入标题',
              icon: 'none'
            })
            return
        }
        if (!dataPost.detailed_requirements) {
            wx.showToast({
              title: '请输入详细需求',
              icon: 'none'
            })
            return
        }
        // if (dataPost.demand_picture.length == 0) {
        //     wx.showToast({
        //       title: '请上传需求图片',
        //       icon: 'none'
        //     })
        //     return
        // }
        if (!dataPost.user_name) {
            wx.showToast({
              title: '请输入姓名',
              icon: 'none'
            })
            return
        }
        if (!dataPost.phone || !/^1[3456789]\d{9}$/.test(dataPost.phone)) {
            wx.showToast({
              title: '请输入正确格式的手机号',
              icon: 'none'
            })
            return
        }
        if (!dataPost.code) {
            wx.showToast({
              title: '请输入验证码',
              icon: 'none'
            })
            return
        }
        if (!dataPost.email) {
            wx.showToast({
              title: '请输入邮箱',
              icon: 'none'
            })
            return
        }
        if (!dataPost.budget_amount) {
            wx.showToast({
              title: '请输入预算金额',
              icon: 'none'
            })
            return
        }
        if (!dataPost.budget_time) {
            wx.showToast({
              title: '请选择预算时间',
              icon: 'none'
            })
            return
        }
        console.log(dataPost)
        app.api.addDemand(dataPost, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                page.setData({
                    dataPost: {
                        service_category_id: '',
                        requirement_title: '',
                        detailed_requirements: '',
                        demand_picture: [],
                        user_name: '',
                        phone: '',
                        code: '',
                        email: '',
                        budget_amount: '',
                        budget_time: '01-01 00:00-02:00',
                        indexCate: ''
                    },
                    isShowWindow: true
                })
                app.db.set('element_order_change',1)
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    onShareAppMessage: function () {
        this.setData({
            isShowWindow: false
        })
        let user_id = app.db.get('element_user_id'), pid = user_id ? user_id : 0
        return {
            title: app.config.shop_name,
            path: '/pages/index/index?pid='+pid
        }
    }
})