const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        key: '',
        list: [],
        pageNow: 1,
        isEnd: false
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
        })
        //改变头部电量条背景色
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        });
        wx.getSystemInfo({
            success: (res) => {
                this.setData({
                    screenWidth: res.screenWidth
                });
            }
        })
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        let page = this, is_end = page.data.isEnd, pageNow = page.data.pageNow
        if (is_end) {
            wx.showToast({
              title: '没有更多了...',
              icon: 'none'
            })
            return
        }
        pageNow++
        page.setData({
            pageNow: pageNow
        })
        page.getcateServiceList()
    },

    /**
     * 设置搜索关键字
     */
    setKey: function (e) {
        this.setData({
            key: e.detail.value
        })
    },

    /**
     * 确认搜索
     */
    goSearch: function () {
        let page = this, key = page.data.key
        if (!key) {
            wx.showToast({
              title: '请输入搜索关键字',
              icon: 'none'
            })
            return
        }
        page.setData({
            pageNow: 1,
            isEnd: false
        })
        page.getcateServiceList()
    },

    /**
     * 获取搜索数据
     */
    getcateServiceList: function () {
        let page = this, key = page.data.key, pageNow = page.data.pageNow, listNow = page.data.list
        console.log([pageNow,key])
        app.api.getcateServiceList("page=1&page_szie=10&cate_id=0&trade_name="+key, function (res) {
            console.log(res)
            if (res.code > 0) {
                if (pageNow == 1) {
                    listNow = []
                }
                if (res.data.length == 0) {
                    if (pageNow == 1) {
                        page.setData({
                            list: []
                        })
                    }
                    page.setData({
                        isEnd: true
                    })
                    wx.showToast({
                      title: '暂无更多数据',
                      icon: 'none'
                    })
                    return
                }
                let list = res.data
                for (let i=0; i<list.length; i++) {
                    listNow.push(list[i])
                }

                page.setData({
                    list: listNow
                })
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })
    },

    /**
     * 详情
     */
    detailPage: function (e) {
        wx.navigateTo({
          url: '../product-details/product-details?id='+e.currentTarget.dataset.id,
        })
    }
})