const util = require('../../utils/util');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        navbarHeight: 0,
        scrollTop: 0,
        money: 0,
        withdrawMoney: ''
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.setData({
            navbarHeight: util.getNavbarHeight(),
            money: options.money
        })
        wx.setNavigationBarColor({
            frontColor: '#ffffff',
            backgroundColor: '#ffffff',
        })
    },
    //
    onPageScroll(e) {
        this.setData({
            scrollTop: e.scrollTop,
        });
    },
    /**
     * 返回上一页
     */
    back() {
        wx.navigateBack({
            delta: 1,
        });
    },

    /**
     * 输入提现金额
     */
    setWithdrawMoney: function (e) {
        this.setData({
            withdrawMoney: e.detail.value
        })
    },

    /**
     * 全部提现
     */
    moneyAll: function () {
        this.setData({
            withdrawMoney: this.data.money
        })
    },

    /**
     * 提现操作
     */
    withdrawAction: function () {
        let page = this, money = page.data.money, withdrawMoney = page.data.withdrawMoney
        if (!withdrawMoney) {
            wx.showToast({
              title: '请输入提现金额',
              icon: 'none'
            })
            return
        }
        if (withdrawMoney <= 0) {
            wx.showToast({
              title: '提现金额必须大于0',
              icon: 'none'
            })
            return
        }
        if (parseInt(money * 100) < parseInt(withdrawMoney * 100)) {
            wx.showToast({
              title: '提现金额大于余额',
              icon: 'none'
            })
            return
        }
        
        app.api.userBalanceWithdraw({transaction_amount: withdrawMoney}, function (res) {
            if (res.code > 0) {
                wx.showToast({
                  title: res.msg,
                })
                app.db.set('element_point_change',1)
                setTimeout (function () {
                    wx.navigateBack({
                      delta: 1,
                    })
                }, 1000)
            } else {
                wx.showToast({
                  title: res.msg,
                  icon: 'none'
                })
            }
        })      
    }
})