
const app = getApp();

const BASE_URL = 'http://ldb.yiqifuo.com';

const http = ({ url = '', param = {}, ...other } = {}) => {
  wx.showLoading({
    title: '请求中..'
  });

  let header = {};
  header['Content-Type'] = 'application/json';
  if(app.globalData.appToken) {
    header['app-token'] = app.globalData.appToken;
  }

  let timeStart = Date.now();
  return new Promise((resolve, reject) => {
    wx.request({
      url: getUrl(url),
      data: param,
      header: header,
      ...other,
      complete: (res) => {
        wx.hideLoading();
        console.log(`耗时${Date.now() - timeStart}`);
        if (typeof res.data.code !== 'undefined') {
          resolve(res.data);
        } else {
          reject(res); 
        }
      }
    })
  })
}

const getUrl = (url) => {
  if (url.indexOf('://') == -1) {
    url = BASE_URL + url;
  }
  return url
}

const _get = (url, param = {}) => {
  return http({
    url,
    param
  })
}

const _post = (url, param = {}) => {
  return http({
    url,
    param,
    method: 'post'
  })
}

const _put = (url, param = {}) => {
  return http({
    url,
    param,
    method: 'put'
  })
}

const _delete = (url, param = {}) => {
  return http({
    url,
    param,
    method: 'put'
  })
}



module.exports = {
  BASE_URL,
  _get,
  _post,
  _put,
  _delete
}